<!-- #include file="../includes/functions.asp" --><%
if (!Session("admin")){
	AddLog(kEvent.accessDenied);
	Response.Redirect(approot);
}

debugLevel=3;
//dont_touch_database=true;

var fso = Server.CreateObject("Scripting.FileSystemObject");
var path = Application("physRoot") + 'uploads\\langup_'+(new Date)*1;

if (!fso.FolderExists(path)) fso.CreateFolder(path);

var aspUp = Server.CreateObject("Persits.Upload")
aspUp.SetMaxSize( 100000, true );
aspUp.Save(path);

var formFiles = ['objects','hier','properties','methods','constants'];
var files={};
for (var i=0,len=formFiles.length;i<len;i++){
	var formName = formFiles[i];
	var aspUpFile = aspUp.files('csv_'+formName);
	if (!aspUpFile) continue;
	var fileName = aspUpFile.fileName;
	var file = fso.OpenTextFile(path+'\\'+fileName);

	DebugOut('Parsing "'+fileName+'"...',-1);
	var startTime = new Date();
	files[formName]=ParseCSV( file.readAll().replace(/[\n\r]+/g,'\n'), true );
	var endTime = new Date();
	DebugOut('...parse complete ('+(endTime-startTime)+'ms)',-1);

	file.close();
	delete file;
}

var langID,langName,url,prefix,copyright,directory,keywords;

if (langID=aspUp.Form("langID").value*1) langName = ExecuteSQL("sp_GetLang",langID).getItem(0,0);
if (langID && langName){
	langName = aspUp.Form('langName').value;
	ExecuteSQL("sp_UpdateLanguage",
		langID,
		langName.toSQLString(),
		aspUp.Form('url').value.toSQLString(),
		aspUp.Form('prefix').value.toSQLString(),
		aspUp.Form('copyright').value.toSQLString(),
		aspUp.Form('directoryName').value.toSQLString(),
		aspUp.Form('keywords').value.toSQLString(),
		aspUp.Form('oview').value.toSQLString()
	);
}else{
	langName = aspUp.Form('langName').value;

	langID = ExecuteSQL("sp_InsertLanguage",
		langName.toSQLString(),
		aspUp.Form('url').value.toSQLString(),
		aspUp.Form('prefix').value.toSQLString(),
		aspUp.Form('copyright').value.toSQLString(),
		aspUp.Form('directoryName').value.toSQLString(),
		aspUp.Form('keywords').value.toSQLString(),
		aspUp.Form('oview').value.toSQLString()
	).getItem(0,0);
}

var objLookup = new ObjectLookup();

AddObjects(files.objects);
AddHierarchy(files.hier);
AddConstants(files.constants);
AddProperties(files.properties);
AddMethods(files.methods);

if (fso.FolderExists(path)) fso.DeleteFolder(path);
delete fso;

CloseConnection();
//Response.Redirect('../objects.asp?langID='+langID);

/************************************************************************************************************************************************/
/************************************************************************************************************************************************/
/************************************************************************************************************************************************/

function AddObjects(lines){
	if (!lines) return;
	DebugOut('AddObjects(...)',1);

	for (var i=0,len=lines.length;i<len;i++){
		var line = lines[i];
		DebugOut(line.toSourceCode(),1);


		if (line.objID && isNaN(line.objID*1)){
			var obj = objLookup.findInLang(line.objID,langID);
			if (!obj) break;
			line.objID=obj.id;
		}

		if (line.objID){
			ExecuteSQL("sp_UpdateObject_Full",
				line.objID,
				langID,
				line.name.toSQLString(),
				line.overview.toSQLString(),
				line.description.toSQLString(),
				line.url.toSQLString(),
				line.keywords.toSQLString()
			);
		}else if (line.name){
			var objID = ExecuteSQL("sp_InsertObject_Full",
				langID,
				line.name.toSQLString(),
				line.overview.toSQLString(),
				line.description.toSQLString(),
				line.url.toSQLString(),
				line.keywords.toSQLString()
			).getItem(0,0);
			objLookup.add(objID,line.name,langID,langName);
		}

	}
}

/************************************************************************************************************************************************/

function AddHierarchy(lines){
	if (!lines) return;
	DebugOut('AddHierarchy(...)',1);

	var objID,cID;
	for (var i=0,len=lines.length;i<len;i++){
		var line = lines[i];
		DebugOut(line.toSourceCode(),1);

		objID = line.parentObjID || objID;

		if (isNaN(objID*1)){
			var obj = objLookup.findInLang(objID,langID);
			if (!obj) continue;
			objID = obj.id;
		}

		var childObjID = line.childObjID;

		if (isNaN(childObjID*1)){
			var obj = objLookup.findInLang(childObjID,langID);
			if (!obj) continue;
			childObjID = obj.id;
		}


		ExecuteSQL("sp_InsertHierarchy",
			objID,
			childObjID
		);
	}
}

/************************************************************************************************************************************************/

function AddConstants(lines){
	if (!lines) return;
	DebugOut('AddConstants(...)',1);

	var objID,cID;
	var cLookup = new ConstantLookup();
	for (var i=0,len=lines.length;i<len;i++){
		var line = lines[i];
		DebugOut(line.toSourceCode(),1);

		objID = line.parentObj || objID;

		//DebugOut(line.parentObj+':'+line.name+':'+line.type+':'+line.value+'::'+objID,-1);

		if (isNaN(objID*1)){
			var obj = objLookup.findInLang(objID,langID);
			if (!obj) continue;
			objID = obj.id;
		}

		var constType = line.type*1;
		if (isNaN(constType)){
			var obj = objLookup.find(line.type);
			if (!obj) continue;
			constType = obj.id;
		}

		if (cID=cLookup.findInObj(line.name,objID)){
			ExecuteSQL("sp_UpdateConstant_Full",
				cID.id,
				line.name.toSQLString(),
				constType,
				line.value.toSQLString()
			);
		}else{
			ExecuteSQL("sp_InsertConstant_Full",
				line.name.toSQLString(),
				objID,
				constType,
				line.value.toSQLString()
			);
		}
	}
}

/************************************************************************************************************************************************/

function AddProperties(lines){
	if (!lines) return;
	DebugOut('AddProperties(...)',1);

	var objID,cID;
	var pLookup = new PropertyLookup();

	for (var i=0,len=lines.length;i<len;i++){
		var line = lines[i];
		DebugOut(line.toSourceCode(),1);

		objID = line.parentObjID || objID;

		if (isNaN(objID*1)){
			var obj = objLookup.findInLang(objID,langID);
			if (!obj) continue;
			objID = obj.id;
		}

		var propType = line.objTypeID*1;
		if (isNaN(propType)){
			var obj = objLookup.find(line.objTypeID,langID);
			if (!obj) continue;
			propType = obj.id;
		}

		var classProp = line.isClassProperty.toLowerCase();
		classProp = classProp=='1' || classProp=='t' || classProp=='true';

		var readOnly = line.readOnly.toLowerCase();
		readOnly = readOnly=='1' || readOnly=='t' || readOnly=='true';

		var prop = pLookup.findInObj(line.name,objID);
		if (prop){
			ExecuteSQL("sp_UpdateProperty_Full",
				prop.id,
				line.name.toSQLString(),
				propType,
				readOnly?1:0,
				line.overview.toSQLString(),
				line.description.toSQLString(),
				line.keywords.toSQLString(),
				classProp?1:0
			);
		}else if (line.name) {
			ExecuteSQL("sp_InsertProperty_Full",
				objID,
				line.name.toSQLString(),
				propType,
				readOnly?1:0,
				line.overview.toSQLString(),
				line.description.toSQLString(),
				line.keywords.toSQLString(),
				classProp?1:0
			);
		}
	}
}

/************************************************************************************************************************************************/

function AddMethods(lines){
	if (!lines) return;
	DebugOut('AddMethods(...)',1);

	var objID,mID;
	var mLookup = new MethodLookup();

	for (var i=0,len=lines.length;i<len;i++){
		var line = lines[i];
		DebugOut('Line #'+i+': '+line.toSourceCode(),1);

		objID = line.parentObjID || objID;
		if (isNaN(objID*1)){
			var obj = objLookup.findInLang(objID,langID);
			if (!obj) continue;
			objID = obj.id;
		}

		mID = line['method name'] || mID;
		if (isNaN(mID*1)){
			var meth = mLookup.findInObj(mID,objID);
			if (meth) mID = meth.id;
		}

		var argName = line['arg name'];

		var returnOrArgTypeID = line.returnOrArgTypeID;
		if (!argName && returnOrArgTypeID=='') returnOrArgTypeID='NULL';
		else if (isNaN(returnOrArgTypeID*1)){
			var obj = objLookup.find(line.returnOrArgTypeID,langID);
			returnOrArgTypeID = (obj && obj.id) || null;
		}

		var classMethodOrArgReqd = line['classMethod or argReqd'];
		classMethodOrArgReqd = classMethodOrArgReqd=='1' || classMethodOrArgReqd=='t' || classMethodOrArgReqd=='true';

		 if (!argName){
			var argNum=0;
			if (isNaN(mID*1)){
				mID = ExecuteSQL("sp_InsertMethod_Full",
					objID,
					mID.toSQLString(),
					returnOrArgTypeID,
					line.overview.toSQLString(),
					line.description.toSQLString(),
					line.keywords.toSQLString(),
					classMethodOrArgReqd?1:0
				).getItem(0,0);
			}else{
				ExecuteSQL("DELETE FROM t_MethodArguments WHERE methodID="+mID);
				ExecuteSQL("sp_UpdateMethod_Full",
					mID,
					returnOrArgTypeID,
					line.overview.toSQLString(),
					line.description.toSQLString(),
					line.keywords.toSQLString(),
					classMethodOrArgReqd?1:0
				);
			}
		}else{
			ExecuteSQL("sp_InsertMethodArgument_Full",
				mID,
				argNum++,
				argName.toSQLString(),
				returnOrArgTypeID,
				classMethodOrArgReqd?1:0,
				line.overview.toSQLString()
			);
		}


	}
}

/************************************************************************************************************************************************/

function ParseCSV(csv,useHeaders){
	var row=[],rows=[row],rc=1,m,l,h,c=/([^,\n]*)([,\n])("?)/g,q=/((?:.|\n)*?[^"](?:"")*)"([,\n])("?)/g,re=c;
	csv.charAt(0)=='"' && (re=q) && (re.lastIndex=1);
	while (m=re.exec(csv)){
		row[row.length]=m[1].replace(/""/g,'"');
		l=re.lastIndex; (re=(m[3]=='"')?q:c).lastIndex=l;
		(m[2]=='\n') && (rows[rc++]=row=[]);
	}
	(l<csv.length) && (/[^"](?:"")*"$/.test(m=csv.substring(l))) && (m=m.slice(0,-1));
	(m!=null) && row.push(m.replace(/""/g,'"'));
	row.length==0 && rows.length--;

	if (useHeaders && (h=rows[0]) && rows.splice(0,1)){
		for (var i=0,len=rows.length;i<len;i++){
			for (var j=0,len2=h.length;j<len2;j++){
				if (rows[i][j]==null) rows[i][j]='';
				rows[i][h[j]] = rows[i][j];
			}
		}
	}

	return rows;
}

/************************************************************************************************************************************************/

function ObjectLookup(){
	this.add=function(id,name,langID,langName){
		DebugOut("INFO: Adding Object #"+id+"/'"+name+"' to the object lookup.",4);
		var obj = {id:id,name:name,langID:langID,langName:langName};
		if (!lookup[name]) lookup[name]=obj;
		else if (lookup[name].length) lookup[name].push(obj);
		else lookup[name] = [lookup[name],obj];
	}

	this.find=function(objName){
		var o = lookup[objName];
		if (!o) return null;
		if (!o.length) return o;

		var errorMsg='',bestChoice;
		for (var i=0,len=o.length;i<len;i++){
			errorMsg+=o[i].toSourceCode()+'\n';
			if (o[i].langID==langID) bestChoice=o[i];
		}
		errorMsg = (bestChoice ? "WARNING: More than one object exists with the name '"+objName+"'; assuming you meant:"+bestChoice.toSourceCode()+".\n" : "ERROR: Object name '"+objName+"' is ambiguous. ") + "Objects with this name are:\n"+errorMsg;
		DebugOut(errorMsg,0);
		return bestChoice || null;
	}

	this.findInLang=function(objName,langID){
		var obj = this.find(objName);
		if (!obj){
			DebugOut("ERROR: Could not find object '"+objName+"'.",0);
			return null;
		}else if (obj.langID!=langID){
			DebugOut("ERROR: The only object I could find with id '"+objName+"' is not in the current language: "+obj.toSourceCode(),0);
			return null;
		}
		return obj;
	}

	var lookup = {};
	var objs = IterableFlavor(ExecuteSQL("sp_GetObjects",null),'id','name','langID','langName');
	for (var i=0,len=objs.length;i<len;i++){
		var obj=objs[i];
		this.add(obj.id,obj.name,obj.langID,obj.langName);
	}
	delete objs;
}


/************************************************************************************************************************************************/

function ConstantLookup(){
	this.add=function(id,name,objID,objName){
		DebugOut("INFO: Adding Constant #"+id+"/'"+name+"' to the constant lookup.",-1);
		var c = {id:id,name:name,objID:objID,objName:objName};
		if (!lookup[name]) lookup[name]=c;
		else if (lookup[name].length) lookup[name].push(c);
		else lookup[name]=[lookup[name],c];
	}
	this.findInObj=function(cName,objID){
		var c = lookup[cName],bestChoice;
		if (!c) return null;
		if (!c.length) return c;

		for (var i=0,len=c.length;i<len;i++) if (c[i].objID==objID){
			bestChoice=c[i];
			break;
		}
		return bestChoice || null;
	}

	var lookup = {};
	var consts = IterableFlavor(ExecuteSQL("sp_GetConstants",langID),'name','objID','objName','oview','id');
	for (var i=0,len=consts.length;i<len;i++){
		var c = consts[i];
		this.add(c.id,c.name,c.objID,c.objName);
	}
	delete consts;
}

/************************************************************************************************************************************************/

function PropertyLookup(){
	this.add=function(id,name,objID,objName){
		DebugOut("INFO: Adding Property #"+id+"/'"+name+"' to the property lookup.",-1);
		var c = {id:id,name:name,objID:objID,objName:objName};
		if (!lookup[name]) lookup[name]=c;
		else if (lookup[name].length) lookup[name].push(c);
		else lookup[name]=[lookup[name],c];
	}
	this.findInObj=function(cName,objID){
		var c = lookup[cName],bestChoice;
		if (!c) return null;
		if (!c.length) return c;

		for (var i=0,len=c.length;i<len;i++) if (c[i].objID==objID){
			bestChoice=c[i];
			break;
		}
		return bestChoice || null;
	}

	var lookup = {};
	var props  = IterableFlavor(ExecuteSQL("sp_GetProperties",langID),'id','name','readOnly','oview','objID','objName');

	for (var i=0,len=props.length;i<len;i++){
		var c = props[i];
		this.add(c.id,c.name,c.objID,c.objName);
	}
	delete props;
}

/************************************************************************************************************************************************/

function MethodLookup(){
	this.add=function(id,name,objID,objName){
		DebugOut("INFO: Adding Method #"+id+"/'"+name+"' to the method lookup.",-1);
		var c = {id:id,name:name,objID:objID,objName:objName};
		if (!lookup[name]) lookup[name]=c;
		else if (lookup[name].length) lookup[name].push(c);
		else lookup[name]=[lookup[name],c];
	}
	this.findInObj=function(cName,objID){
		var c = lookup[cName],bestChoice;
		if (!c) return null;
		if (!c.length) return c;

		var errorMsg='',bestChoice;
		for (var i=0,len=c.length;i<len;i++){
			errorMsg+=c[i].toSourceCode()+'\n';
			if (c[i].objID==objID){
				if (!bestChoice) bestChoice=c[i];
				else{
					if (!bestChoice.length) bestChoice=[bestChoice];
					bestChoice.push(c[i]);
				}
			}
		}
		if (!bestChoice) return null;
		if (!bestChoice.length) return bestChoice;
		DebugOut("ERROR: More than one method with name '"+cName+"' exists for object id#"+objID,0);
		return null;
	}

	var lookup = {};
	var meths  = IterableFlavor(ExecuteSQL("sp_GetMethods",langID),'id','name','objID','objName');

	for (var i=0,len=meths.length;i<len;i++){
		var c = meths[i];
		this.add(c.id,c.name,c.objID,c.objName);
	}
	delete meths;
}



%>DONE!