<%
debugLevel=0;

var kEvent = { pageView:1, addLanguage:50, addObject:51, addConstant:52, addProperty:53, addMethod:54, addArgument:55, editLanguage:60, editObject:61, editConstant:62, editProperty:63, editMethod:64, editArgument:65, deleteLanguage:70, deleteObject:71, deleteConstant:72, deleteProperty:73, deleteMethod:74, deleteArgument:75, adminLogin:10, search:100, accessDenied:200 };
var kError = { noError:0, loginNotFound:1, passwordIncorrect:2, sessionTimedOut:3, insufficientAccessLevel:4, loginDisabled:5 };

var errorMessages = [];
errorMessages[kError.loginNotFound] = "No team could be found for that login.";
errorMessages[kError.passwordIncorrect] = "The Password you typed is not correct.<br><i>Passwords are case-sensitive, if that helps.</i>";
errorMessages[kError.sessionTimedOut] = "For security reasons, you have been automatically logged out after "+Session.Timeout+" minutes of inactivity.<br>Please login again to re-enter the site.";
errorMessages[kError.insufficientAccessLevel] = 'You do not have the access privileges required to view this page.<br>If you think this is an error, please <a href="mailto:'+Application("adminEmail")+'">email the administrator</a>.';
errorMessages[kError.loginDisabled] = 'Logins for your team have been disabled.<br>Please <a href="mailto:'+Application("adminEmail")+'">email the system administrator</a> or your project administrator if you feel this is an error.';


var approot = Application("approot");
var reqd = '<span class="reqd help" title="This field must be filled out.">*</span>';

var Global=this;

function AddLog(eventType,userID,langID,objID,constID,propID,methID,argID,data){
	var ip = Request.ServerVariables("REMOTE_ADDR")().toSQLString();
	if (ip=="127.0.0.1") return;

	if (!userID) userID=null;
	if (!langID) langID=null;
	if (!objID) objID=null;
	if (!constID) constID=null;
	if (!propID) propID=null;
	if (!methID) methID=null;
	if (!argID) argID=null;
	if (data==null) data=Request.ServerVariables("SCRIPT_NAME")()+(Request.ServerVariables("QUERY_STRING")()!=""?("?"+Request.ServerVariables("QUERY_STRING")()):"");
	data=data.toSQLString();

	ExecuteSQL("sp_InsertLog",eventType,ip,userID,langID,objID,constID,propID,methID,argID,data);
}

Date.prototype.customFormat = function(formatString){
	var YYYY,YY,MMMM,MMM,MM,M,DDDD,DDD,DD,D,hhh,hh,h,mm,m,ss,s,ampm,AMPM,dMod,th;
	var dateObject = this;
	YY = ((YYYY=dateObject.getFullYear())+"").substr(2,2);
	MM = (M=dateObject.getMonth()+1)<10?('0'+M):M;
	MMM = (MMMM=["January","February","March","April","May","June","July","August","September","October","November","December"][M-1]).substr(0,3);
	DD = (D=dateObject.getDate())<10?('0'+D):D;
	DDD = (DDDD=["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"][dateObject.getDay()]).substr(0,3);
	th=(D>=10&&D<=20)?'th':((dMod=D%10)==1)?'st':(dMod==2)?'nd':(dMod==3)?'rd':'th';
	formatString = formatString.replace("#YYYY#",YYYY).replace("#YY#",YY).replace("#MMMM#",MMMM).replace("#MMM#",MMM).replace("#MM#",MM).replace("#M#",M).replace("#DDDD#",DDDD).replace("#DDD#",DDD).replace("#DD#",DD).replace("#D#",D).replace("#th#",th);

	h=(hhh=dateObject.getHours());
	if (h==0) h=24;
	if (h>12) h-=12;
	hh = h<10?('0'+h):h;
	AMPM=(ampm=hhh<12?'am':'pm').toUpperCase();
	mm=(m=dateObject.getMinutes())<10?('0'+m):m;
	ss=(s=dateObject.getSeconds())<10?('0'+s):s;
	return formatString.replace("#hhh#",hhh).replace("#hh#",hh).replace("#h#",h).replace("#mm#",mm).replace("#m#",m).replace("#ss#",ss).replace("#s#",s).replace("#ampm#",ampm).replace("#AMPM#",AMPM);
}
Date.prototype.sqlDate = function(){ return this.customFormat("'#MM#/#DD#/#YYYY#'") }
Date.prototype.sqlDateTime = function(){ return this.customFormat("'#MM#/#DD#/#YYYY# #hhh#:#mm#:#ss#'") }
Date.prototype.standardFormat = function(){ return this.customFormat("#M#/#D#/#YYYY#") }

String.prototype.toSQLString=  function(){ var val=this.valueOf(); return (val.length==0)?null:"'"+val.replace(/'/g,"''")+"'" }
String.prototype.toSQLNumber=  function(){ var val=this.valueOf(); return (val.length==0 || isNaN(val*=1))?null:val }
String.prototype.toSQLDate=    function(){ var val=this.valueOf(); return (val.length==0 || isNaN(val=new Date(val)))?null:val.sqlDate() }
String.prototype.toSQLDateTime=function(){ var val=this.valueOf(); return (val.length==0 || isNaN(val=new Date(val)))?null:val.sqlDateTime() }

String.prototype.toJSString   =function(){ return this.replace(/'/g,"\\'").replace(/"/g,'\\"').replace(/[\n\r]/g,'\\n') }

//Array.prototype.forEach = function(f){ for (var i=0,len=this.length;i<len;i++) f(this[i],i,i==0,i==len-1) }

function Text2HTML(str,forTextArea,abbrLimit,allowHTML){
	if (abbrLimit==true) abbrLimit=300;
	var abbreviateStopStrings = [". ",".\r",":\r","? ","?\r","\r"];
	var html = str+"";
	if (html=="" || html=="null" || html=="undefined") return "";
	if (!allowHTML)	html = Server.HTMLEncode(html);

	if (abbrLimit && html.length>abbrLimit){
		var minLoc = html.length;
		for (var i=0,len=abbreviateStopStrings.length;i<len;i++){
			loc = html.indexOf(abbreviateStopStrings[i],abbrLimit);
			if (loc>0 && loc<minLoc) minLoc = loc;
		}
		html = html.substr(0,minLoc+1)+"  [cont'd]";
	}
	if (forTextArea) html = html.replace(/\r\n/gi,"&#13;").replace(/"/g,"\&quot;");
	else {
		html = html.replace(/(\r\n){2,}/g,"</p><p>"); //this is close to the right thing to do, but can produce invalid HTML
		html = html.replace(/\r\n/g,"<br>");
		html = html.replace(/\[(\/?(b|i|code))\]/gi,"<$1>");
		html = html.replace(/\[url=(http:\/\/[^]]+)\]/gi,"<a href=\"$1\">");
		html = html.replace(/\[url\](http:\/\/[^[]+)/gi,"<a href=\"$1\">$1");
		html = html.replace(/\[url\]([^[]+)/gi,"<a href=\"http://$1\">$1");
		html = html.replace(/\[email\]([^[]+)/gi,"<a href=\"mailto:$1\">$1");
		html = html.replace(/\[\/(url|email)\]/gi,"</a>");
		html = html.replace(/\[img\](http:\/\/[^[]+)\[\/img\]/gi,"<img src=\"$1\">");
	}
	return html;
}


function MyEncrypt(str){
	if (str==null || str=='') return '';
	var cryptor = Server.CreateObject("AspCrypt.Crypt");
	var strSalt = "ss";
	var encryptedStr = cryptor.Crypt(strSalt, str);
	delete cryptor;
	return encryptedStr;
}





function DebugOut(msg,lv){
	if (this.debugLevel==null || this.debugLevel==false) this.debugLevel=0;
	if (this.debugLevel<lv) return;
	Response.Write("<xmp>"+msg+"</xmp>\n");
	if (Response.Buffer) Response.Flush();
}

var connection;
function OpenConnection(){
	DebugOut("OpenConnection()",2);
	connection = Server.CreateObject("ADODB.Connection");
	connection.connectionstring = Application("connectionString")
	connection.Open();
	DebugOut(" -- OpenConnection successful",4);
}
function CloseConnection(){
	DebugOut("CloseConnection()",2);
	if (!this.connection) return;
	connection.Close();
	connection=null;
	delete connection;
	DebugOut(" -- CloseConnection successful",4);
}

function ExecuteSQL(sqlString){
	for (var i=1,len=arguments.length;i<len;i++) sqlString+=(i==1?" ":",")+arguments[i];
	DebugOut('ExecuteSQL("'+sqlString+'")',1);
	if (this.showSQL) ShowSQL(sqlString);
	if (!connection) OpenConnection();

	if (Global.dont_touch_database) resultsAsVBArray = new EmptyVBArray();
	else{
		var adStateOpen = 1;
		var resultsAsVBArray;
		var rs = connection.Execute(sqlString);
		if (!rs || rs.State!=adStateOpen || rs.BOF || rs.EOF) resultsAsVBArray = new EmptyVBArray();
		else resultsAsVBArray = rs.GetRows();
		if (rs.State==adStateOpen) rs.Close();
		delete rs;
		DebugOut('ExecuteSQL("'+sqlString+'") -- returning '+(resultsAsVBArray.ubound(2)+1)+' rows',4);
	}

	return resultsAsVBArray;
}
function EmptyVBArray(){
	DebugOut("EmptyVBArray()",4);
	this.dimensions = function(){ return 0 };
	this.ubound = this.lbound = function(){ return -1 };
	this.getItem = this.toArray = function(){ return null };
}

function IterableFlavor(vbArray){
	DebugOut("IterableFlavor("+vbArray+")",4);
	var a = [];
	for (var i=0,len=vbArray.ubound(2);i<=len;i++){
		var p = {};
		for (var j=1,len2=arguments.length;j<len2;j++){
			//Response.Write('p.'+arguments[j]+' = "'+vbArray.getItem(j-1,i)+'" (index '+(j-1)+')<br>');
			p[arguments[j]]=vbArray.getItem(j-1,i);
		}
		a[i]=p;
	}
	return a;
}

function AssignProperties(vbArray){
	DebugOut("AssignProperties("+vbArray+")",4);
	var o = {};
	for (var j=1,len=arguments.length;j<len;j++) o[arguments[j]]=vbArray.getItem(j-1,0);
	return o;
}

function Debug_AllProperties(label,obj,indent){
	if (!indent) indent=0;
	var out="";
	var tabs="";
	for (var i=0;i<indent;i++) tabs+="--";
	for (var a in obj){
		if (typeof(obj[a])=='object') out+=tabs+(indent==0?label:'')+"."+a+"<br>\n"+Debug_AllProperties(null,obj[a],indent+1);
		else out+=tabs+(indent==0?label:'')+"."+a+" : "+obj[a]+"<br>\n";
	}
	return out;
}

function SortByName(a,b){ return a.name<b.name?-1:a.name>b.name?1:0 }

function ObfuscateEmail(str){
	for (var out='',i=0,len=str.length;i<len;i++){
		var rnd,n=str.charCodeAt(i);
		out+=((rnd=Math.random())<.1)?('&#'+n+';'):(rnd<.2)?('%'+n.toString(16)):str.charAt(i);
	}
	return out;
}

function SetLanguage(langID){
	if (!langID) langID=Request("langID")();
	if (langID){
		var lang=AssignProperties(ExecuteSQL("sp_GetLang",langID),'name','url','prefix');
		if (lang.name!=null){
			Session('langID')=langID;
			Session('langName')=lang.name;
			Session('langUrl')=lang.url;
			Session('langPrefix')=lang.prefix;
		}
	}
	langID=Session("langID");
	langName=Session("langName");
	langUrl=Session("langUrl");
}

SetLanguage(this.langID);


Object.prototype.toSourceCode=function(hier,lv,forObj){
	var out,tabs='',idre=/^[a-z_][a-z0-9_]*$/i;
	if (!lv) lv=0;
	if (hier) tabs=Math.pow(10,lv).toString().substr(1).replace(/0/g,"\t");
	if (this.constructor==Array){
		out=(forObj?'':tabs)+'['+(hier?'\n':'');
		for (var i=0,len=this.length;i<len;i++) out+=((this[i]!=null)?this[i].toSourceCode(hier,lv+1):'null')+(i<(len-1)?',':'')+(hier?'\n':'');
		return out+tabs+']';
	}else if(this.constructor==Object){
		out=(forObj?'':tabs)+'{'+(hier?'\n':'');
		for (var key in this) if (key!='toSourceCode') out+=tabs+(hier?'\t':'')+(idre.test(key)?key:("'"+key+"'"))+":"+(this[key]==null?'null':this[key].toSourceCode(hier,lv+1,true))+","+(hier?'\n':'');
		out=out.replace(/,(\n?)$/,'$1');
		return out+tabs+'}';
	}else if(this.constructor==String) return (forObj?'':tabs)+"'"+this.toString()+"'";
	else return (forObj?'':tabs)+this.toString();
}

function WriteHierarchy(pID,langID,lv){
	var childs;
	if (langID!=null) childs=IterableFlavor(ExecuteSQL("sp_GetHierChildren",langID,pID),'id','name','overview','childCt');
	else childs=IterableFlavor(ExecuteSQL("sp_GetHierChildren",null,pID),'id','name','langID','langPrefix','childCt');
	if (childs.length>0){
		var tabs=Math.pow(10,lv).toString().substr(1).replace(/0/g,'\t');
		Response.Write('<ul>\n');
		for (var i=0,len=childs.length;i<len;i++){
			var obj=childs[i];
			Response.Write(tabs+'\t<li><a href="object.asp?id='+obj.id+'">'+(obj.langPrefix?obj.langPrefix:'')+obj.name+'</a>'+(obj.overview?(' - '+obj.overview):''));
			if (obj.childCt) WriteHierarchy(obj.id,langID,lv+1);
			Response.Write('</li>\n');
		}
		Response.Write(tabs+'</ul>');
		return true;
	} else return false;
}

%>
