<!-- #include file="includes/functions.asp" --><%
Response.Buffer=false;

ObjectLinkCache={};
PropertyLinkCache={};
MethodLinkCache={};
ObjectUsedLinkCache={};

Server.ScriptTimeout=4800;
debugLevel=0;
var physroot = Application("physRoot");
var cygwinBin = Application("cygwinBinDir");

var fso = Server.CreateObject("Scripting.FileSystemObject");
var xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");

var createDate = new Date();
var dateStr = createDate.customFormat('#YYYY##MM##DD#');
var dirName = 'ObjJob_'+dateStr;
var staticRoot = physroot+dirName+'\\';

if (!fso.FolderExists(staticRoot)) fso.CreateFolder(staticRoot);
DebugOut("Working in "+staticRoot,-1);

var failedPages=[];
RunTheRest();

if (failedPages.length){
	DebugOut("The following "+failedPages.length+" pages failed:",-1);
	for (var i=0,len=failedPages.length;i<len;i++){
		DebugOut(failedPages[i].path,-1);
		DebugOut(failedPages[i].html,-1);
	}
}else{
	WritePage('default.asp',staticRoot+"\\index.html",0);
	WritePage('languages.asp',staticRoot+"\\languages.html",0);
	CopyStyle();
	WriteInclude();
	CreateArchive();
	//DeleteLastWeek();
}


// ***************************************************************************************************
// ***************************************************************************************************
// ***************************************************************************************************

function RunTheRest(){
	var langs = IterableFlavor(ExecuteSQL("sp_GetLanguages"),'id','name','url','dirName');
	for (var i=0,len=langs.length;i<len;i++){
		var lang=langs[i];
		var curLangID=lang.id;

		if (Request("langID")() && curLangID!=Request("langID")()) continue;

		var langDir = staticRoot+CleanName(lang.dirName);
		if (!fso.FolderExists(langDir)) fso.CreateFolder(langDir);
		DebugOut("Working in "+langDir,-1);

		WritePage('hierarchy.asp?langID='+curLangID,langDir+'\\'+'hierarchy.html',1);
		WritePage('objects.asp?langID='+curLangID,langDir+'\\'+'objects.html',1);
		WritePage('constants.asp?langID='+curLangID,langDir+'\\'+'constants.html',1);
		WritePage('properties.asp?langID='+curLangID,langDir+'\\'+'properties.html',1);
		WritePage('methods.asp?langID='+curLangID,langDir+'\\'+'methods.html',1);

		var objs=IterableFlavor(ExecuteSQL('sp_GetObjects',curLangID),'id','name');
		for (var j=0,len2=objs.length;j<len2;j++){
			var now = new Date();

			var obj=objs[j];
			var objDir = langDir+'\\'+CleanName(obj.name);
			if (!fso.FolderExists(objDir)) fso.CreateFolder(objDir);
			DebugOut(now.customFormat('#hhh#:#mm#:#ss#')+" - working in "+objDir,-1);

			var url = "object.asp?id="+obj.id;
			var path = objDir+'\\index.html';
			WritePage(url,path,2);

			var props=IterableFlavor(ExecuteSQL('sp_GetObjectProperties',obj.id),'id','name');
			for (var k=0,len3=props.length;k<len3;k++){
				var prop = props[k];
				var url = "property.asp?id="+prop.id;
				var path = objDir+'\\prop_'+CleanName(prop.name)+'.html';
				WritePage(url,path,2);
			}
			var meths=IterableFlavor(ExecuteSQL('sp_GetObjectMethods',obj.id),'id','name');
			for (var k=0,len3=meths.length;k<len3;k++){
				var meth = meths[k];
				var url = "method.asp?id="+meth.id;
				var path = objDir+'\\meth_'+CleanName(meth.name)+'.html';
				WritePage(url,path,2);
			}

			var url = "objectused.asp?id="+obj.id;
			var path = objDir+'\\WhereUsed.html';
			WritePage(url,path,2);
		}
	}
}



function CleanName(n){
	DebugOut('CleanName("'+n+'")',4);
	return n.replace(/\W/g,'_');
}

function WritePage(url,filepath,depth){
	DebugOut(" -- WritePage('"+url+"','"+filepath+"',"+depth+")",-1);

	var localURL = 'http://localhost'+approot+url;
	localURL+= ((/\?/.test(localURL))?'&':'?')+'crawling=1';

	//DebugOut(" -- WritePage('"+url+"','"+filepath+"',"+depth+") -- url:"+localURL,-1);

	rootRel = Math.pow(10,depth).toString().substr(1).replace(/0/g,'../');
	langRel = depth>0?Math.pow(10,depth-1).toString().substr(1).replace(/0/g,'../'):'';

	xmlhttp.Open("GET",localURL, false);
	xmlhttp.Send();
	var html = xmlhttp.responseText;

	html=html.replace(/"includes/g,'"'+rootRel+'includes');
	html=html.replace(/default.asp/gi,rootRel+'index.html');
	html=html.replace(/languages.asp/gi,rootRel+'languages.html');

	html=html.replace(/(hierarchy|objects|properties|methods|constants).asp\?langID=(\d+)/gi,LanguageLink);
	html=html.replace(/(hierarchy|objects|properties|methods|constants).asp/gi,langRel+"$1.html");
	if (depth==0) html=html.replace(/<a href="(hierarchy|objects|properties|methods|constants)\.html">[^<]+<\/a>/g,'');

	html=html.replace(/object.asp\?id=(\d+)/g,ObjectLink);
	html=html.replace(/property.asp\?id=(\d+)/g,PropertyLink);
	html=html.replace(/method.asp\?id=(\d+)/g,MethodLink);

	html=html.replace(/objectused.asp\?id=(\d+)/gi,ObjectUsedLink);

	html=html.replace(/<div id="description"><p><\/p><\/div>/g,'');

	html=html.replace(/<p id="contact">.+<\/p>/g,'<p id="contact">Copyright &copy; 2003 <a href="">Gavin Kistner</a>. Info from '+createDate.customFormat('#YYYY#-#MMM#-#D#')+'; see <a href="http://phrogz.net/ObjJob/'+url+'">ObjJob</a> for the most current version.</p>');


	try{
		var f = fso.CreateTextFile(filepath, true);
		f.Write(html);
		f.Close();
	}catch(e){
		failedPages.push({path:filepath,html:html.replace(/[^\t-~]/g,'**zap**&**zap**')});
	}
}

function LanguageLink(orig,page,id){
	var lang = AssignProperties(ExecuteSQL("sp_xLangLookup",id*1),'langDir');
	return rootRel+lang.langDir+'/'+page+'.html';
}

function ObjectLink(orig,id){
	var html = ObjectLinkCache[id];
	if (!html){
		var obj = AssignProperties(ExecuteSQL("sp_xObjLookup",id*1),'langDir','name');
		html = ObjectLinkCache[id] = rootRel+obj.langDir+'/'+CleanName(obj.name)+'/index.html';
	}
	return html;
}

function PropertyLink(orig,id){
	var html = PropertyLinkCache[id];
	if (!html){
		var prop = AssignProperties(ExecuteSQL("sp_xPropLookup",id*1),'langDir','objName','name');
		html = PropertyLinkCache[id] = rootRel+prop.langDir+'/'+prop.objName+'/prop_'+CleanName(prop.name)+'.html';
	}
	return html;
}

function MethodLink(orig,id){
	var html = MethodLinkCache[id];
	if (!html){
		var meth = AssignProperties(ExecuteSQL("sp_xMethLookup",id*1),'langDir','objName','name');
		html = MethodLinkCache[id] = rootRel+meth.langDir+'/'+meth.objName+'/meth_'+CleanName(meth.name)+'.html';
	}
	return html;
}

function ObjectUsedLink(orig,id){
	var html = ObjectUsedLinkCache[id];
	if (!html){
		var obj = AssignProperties(ExecuteSQL("sp_xObjLookup",id*1),'langDir','name');
		html = ObjectUsedLinkCache[id] = rootRel+obj.langDir+'/'+CleanName(obj.name)+'/WhereUsed.html';
	}
	return html;
}


function WriteInclude(){
	var inc = physroot+'latest.txt';
	var f = fso.CreateTextFile(inc, true);
	f.Write('...or download the <a href="ObjJob_'+dateStr+'.tar.bz2">bzip2</a> or <a href="ObjJob_'+dateStr+'.tar.gz">gzip</a> static archive of the site, last updated '+createDate.customFormat('#YYYY#-#MMM#-#D#')+'.');
	f.Close();
}

function CopyStyle(){
	var incDir = staticRoot+"includes";
	if (!fso.FolderExists(incDir)) fso.CreateFolder(incDir);
	DebugOut("Created "+incDir,-1);

	WritePage('includes/styles.css',incDir+'\\styles.css',1);
}

function CreateArchive(){
	var wsh = Server.CreateObject("WScript.Shell");
	var physrootcyg = '/cygdrive/'+physroot.replace(':','').replace(/\\/g,'/');
	var cmd = cygwinBin+'bash -c "cd '+physrootcyg+';/usr/bin/tar -cf '+dirName+'.tar '+dirName+';/usr/bin/cp '+dirName+'.tar '+dirName+'.tar2;/usr/bin/gzip '+dirName+'.tar;/usr/bin/mv '+dirName+'.tar2 '+dirName+'.tar;/usr/bin/bzip2 '+dirName+'.tar"';
	DebugOut(cmd,-1);
	wsh.Run(cmd);
}

function DeleteLastWeek(){
	DebugOut('Deleting static folders:',-1);
	var d = new Date(),p;
	for (var i=0;i<10;i++){
		d.setDate(createDate.getDate()-i);
		p=physroot+'ObjJob_'+d.customFormat('#YYYY##MM##DD#');
		if (fso.FolderExists(p)){
			DebugOut('...deleting '+p,-1);
			fso.DeleteFolder(p);
		}
	}
}

CloseConnection();
%>
