module Ramaze::Helper::ItemLinkers
  def object_link( object, display_name=nil, o_id=nil, prefix=nil, anchor=nil )
    generic_link( :object, prefix || object.language.prefix, o_id || object.id, display_name || object.name, anchor )
  end  
  def property_link( property, display_name=nil, p_id=nil, prefix=nil, anchor=nil )
    generic_link( :property, prefix || property.object.language.prefix, p_id || property.id, display_name || property.name, anchor )
  end  
  def method_link( method, display_name=nil, m_id=nil, prefix=nil, anchor=nil )
    generic_link( :method, prefix || method.object.language.prefix, m_id || method.id, "#{display_name || method.name}()", anchor )
  end
  def generic_link( kind, prefix, id, name, anchor=nil )
    "<a href='/#{prefix}/#{kind}/#{id}#{"##{anchor}" if anchor}' class='#{kind}'>#{name}</a>"
  end
end